var EventEmitter = require('events').EventEmitter,
fs = require('fs'),                
path = require('path'),
Mongo = require('sk/node/db/mongo').Mongo,
Url = require('url'),
utils = require('sk/node/utils'),
smart = require('sk/core/smart').smart;


//fuck Joose and its over--complex architecture. Fuck it all.
try
{
	require('joose')
	require('joosex-namespace-depended')
	require('hash')
}catch(e)
{
	
}

function CacheFactory()
{  
	var cachers = {};

	this.addCacher = function(type,cacher)
	{
		cachers[type] = cacher;
	}                          

	this.getNewCacher = function(type,key,ttl)
	{
		var cls = cachers[type];

		if(!cls)
		{

			console.warning('cacher "'+type+'" doesn\'t exist. using none.');
			cls = PassThruCacher;
		} 

		return new cls(key,ttl);
	}
} 

var factory = new CacheFactory(),Cacher;


function Cache()
{      
	var cache = {};

	this.open = function(type,key,ttl,onNew,onOpen)
	{                 
		onOpen = onOpen || function(){}

		if(!cache[type])
		{
			cache[type] = {};
		}                    

		var cacher = cache[type][key] = cache[type][key] || factory.getNewCacher(type,key,ttl);  

		cacher.init(function()
		{

			if(!cacher.ondispose)
			cacher.ondispose = function()
			{                         
				delete cache[type][key];
			}

			var isOpen = cacher.isNew();     
			
			onOpen(cacher);  
			
			if(isOpen && !cacher.owner)
			{                            
				cacher.owner = true;
				onNew(cacher);
			}
			else
			{                  
				cacher.sendCached();
			}
		});
	} 
}


var Cacher =
{   
	complete:false, 
	owner:false,
	disposed:false, 
	ttl:-1,
	key:null,  
	created:null,   
	eventListeners:{},
	__construct:function(key,ttl)
	{             
		this.key = key;       
		this.ttl = ttl*1000;//seconds  
		this.eventListeners = {};
	},
	emitter:function()
	{
		if(!this._emitter)
		{
			this._emitter = new EventEmitter();
			// this._emitter.setMaxListeners(0);
		}
		
		return this._emitter;
	}, 
	init:function(callback)
	{
		callback();
	},
	isNew:function()
	{  
		return !this.complete || !this.disposed;
	},
	on:function(type,callback)
	{
		this.eventListeners[type] = 1;
		
		this.emitter().on(type,callback);
	},   
	removeListener:function(type,callback)
	{
		this.emitter().removeListener(type,callback);
	},
	record:function(type,chunk)
	{
		if(type == 'end' && !this.complete) throw new Error('You must call the end function for finishing a cached value.');
	
		this.emitter().emit(type,chunk);
	},
	end:function(chunk)
	{                       
		this.complete = true;
		this.record('end',chunk);
		this.end2(chunk);

		if(this.ttl > 0)
		{                                               
			var self = this;

			setTimeout(function()
			{                                    
				self.dispose();
			}
			,
			this.ttl*1000);        
		}   
		else
		{                                                
			this.dispose();
		}
		
		this.removeListeners();
	},      
	removeListeners:function()
	{                
		for(var i in this.eventListeners)       
		{   
			this.emitter().removeAllListeners(i);     
		}  
		this.eventListeners = {};
	},         
	end2:function(chunk){},//override    

	sendCached:function()
	{  
		//override me
	},
	sendCached2:function(){},    
	delink:function()
	{
		if(this.ondispose) this.ondispose();
		this.ondispose = undefined;
	} 
	,dispose:function()
	{         
		                         
		this.delink();               
		this.complete = true; 
		this.disposed = true;                        
		this.removeListeners();
		this.dispose2();    
	},   
	dispose2:function(){}
};

Cacher = utils.extend({},Cacher);


//doesn't cache anything
var PassThruCacher = 
{
	__construct:function(key,ttl)
	{
		this.buffer = [];  
		this._super(key+Math.random(),ttl);
	}
	,record:function(type,chunk)
	{
		this.emitter().emit(type,chunk);
		this._super(type,chunk);
	} 
	,sendCached:function(){},  
	dispose2:function(){}
}

PassThruCacher = utils.extend(Cacher,PassThruCacher);

var MemCacher = 
{    
	__construct:function(key,ttl)
	{
		this.buffer = [];  
		this._super(key,ttl);
	}
	,record:function(type,chunk)
	{
		this.buffer.push({type:type,chunk:chunk});
		this._super(type,chunk);
	} 
	,sendCached:function()
	{             
		var s = this;   
		this.buffer.forEach(function(d)
		{
			s.emitter().emit(d.type,d.chunk); 
		});

		this.removeListeners();
	},  
	dispose2:function()
	{
		this.buffer = null;   
	}
};

MemCacher = utils.extend(Cacher,MemCacher);




var cdb = new Mongo('cache');
var c_data = cdb.collection('data');


var DBCacher = 
{
	buffer:[],
	__construct:function(key,ttl)
	{                       
		this._super(key,ttl);
	}
	,init:function(callback)
	{
		var s = this;   
		                          

		this.getCache(function(data)
		{                                                                  
			if(data)
			{                                                                                                                             
				if(data.deleteAt.getTime() >  new Date().getTime())
				{                                                               
					s.complete = data.complete;
					s.disposed = true; 
				}
				else
				{                           
					//just wanna dump the data in the database...      	                   
					s.dispose2();           
				}
			}                           
			else
			{                                           
				var date = new Date();
				date.setTime(date.getTime() + this.ttl)
				c_data.insert({key:s.key,deleteAt:date},function(){});
		    }

			callback();
		});
	}
	,record:function(type,chunk)
	{  
		var complete = type == 'end';
		var deleteAt = new Date();
		deleteAt.setTime(deleteAt.getTime() + this.ttl || 1000*60*60*24);
		c_data.update({key:this.key},{$set:{complete:complete,deleteAt:deleteAt},$push:{rec:{type:type,chunk:chunk}}},function(){});

		this._super(type,chunk);
	}
	,sendCached:function()
	{
		var s = this; 


		this.getCache(function(data)
		{
			if(data && data.rec)
			{
				data.rec.forEach(function(rec)
				{
					s.emitter().emit(rec.type,rec.chunk);
				});

			}
			else
			if(s.ondispose)
			{
				s.ondispose();
			}	
			
			/*okay, it took me quite a LONG time finding where this particular bug occured, but allow me to explain why this is here:
			
			Start off by loading TWO different urls that redirect to the SAME url (short urls). What happens is the first url redirects. it's still open, and then the second
			url redirects and uses the SAME CACHER. At THAT point, the SECOND chunk of code is sent the cached data, and at the end we need to see if
			we're finished, otherwise NEITHER of the urls loading will ever finish.*/
			
			if(s.complete)
			s.removeListeners();
		});
	}
	,dispose2:function()
	{                                                                          
		c_data.remove({key:this.key},function(){});
	}
	,getCache:function(callback)
	{
		var s = this;
		
		
		// return callback({deleteAt:new Date(),rec:[{end:'hello',chunk:null}]});
		
		c_data.findOne({key:this.key},function(err,data)
		{
			// return callback({deleteAt:new Date(),rec:[{end:'hello',chunk:null}]});
			// cacher.end(data);
			callback(data)
		});
		
		/*Cacher.open('memory',this.key,5000,function(cacher)
		{
			c_data.findOne({key:this.key},function(err,data)
			{
				cacher.end(data || false);
			});
		},function(cacher)
		{
			cacher.on('end',function(data)
			{
				callback(data);
			})
		})*/
			
		
	}
}         


var c_fsinfo = cdb.collection('fs');    


if(process.env.SLAVE)
{                 
	
	//every 10 seconds = min cache time for fs.
	smart.interval(function()
	{                     
		//fs cache        
		c_fsinfo.find({deleteAt:{$lt:new Date()}},function(err,cursor)
		{          
			function removeFile(err,item)
			{                                                       
				if(!item) return;
				              
				console.verbose('removing cached file '+item.path);  
				               
				//remove from the database
				c_fsinfo.remove({_id:item._id},function(){});
				                          
				//unlink the cached file so the HTTPCacher doesn't find it, forcing to 
				//open a new connection
				fs.unlink(item.path,function()
				{
					cursor.nextObject(removeFile);
				})
			} 
			
			cursor.nextObject(removeFile);
		});  
		
		//mongo cache 
		 c_data.remove({deleteAt:{$lt:new Date()}},function(){});    
		
	},10000,true);
}        
                           
var HTTPCacher = 
{
	buffer:[],
	__construct:function(key,ttl)
	{                       
		this._super(key,ttl);
	}
	,init:function(callback)
	{                        
		var parts = Url.parse(this.key),
			self = this;

		var start = new Date().getTime();     
		                                       

		var directory = ((parts.hostname || 'localhost/')+parts.pathname).split('/'),
		fileName = Hash.md5(directory.pop()+(directory.hash || directory.search || ''));   
                                                 

		var cacheRootDir = this._rootCacheDir = '/tmp/';
		var cacheDir = this._cacheDir = '/clove/cache/'+directory.join('/');    
			                        

		var absPath = self._absPath = cacheRootDir+cacheDir+'/'+fileName; 
		
		
		                 
		                      
		path.exists(absPath,function(exists)
		{                      
			self._exists = exists; 
			                        
			if(exists)
			{                       
				c_fsinfo.fast.findOne({path:self._absPath},function(err,item)
				{          
					//if the item exists, we use it. Don't check for ttl because that's handled elsewhere         
					if(item)
					{                     
						self._response = item.response;
						self.complete = true; 
						self.owner = true;    
					} 
					callback();
				}) 
			}
			else
			{                         				
				self.owner = false;
				self.complete = false;
				callback();  
			}
		});        
	}	
	
	//types supported: data,end.
	,record:function(type,chunk)
	{                         
		if(type != 'data' && type != 'end' && type != 'response') throw new Error('Attempt record unsupported action: '+type);                   
                             
        
		/*if(this.compress)
		{                                         
			this._gzip = new compress.Gzip();   
			this._gzip.init();      
		}*/
                              
		if(this.ttl > -1)
		{        
			
			if(!this._ws) 
			{                             
				//this is synchronous...
				this.startWS();     
			}                

			if(type == 'end')
			{    
				//chunk added at the end? - re-record it as data     
				if(chunk)
				{
					this.record('data',chunk);
				}

				this._ws.end(); 
				
				if(this._gzip)
				{
					this._gzip.end();
				} 

				if(!this._response) throw new Error('response not sent');

				//shove the ttl in the database   
				if(this.ttl > 0)
				c_fsinfo.insert({path:this._absPath,deleteAt:new Date(new Date().getTime()+this.ttl),response:this._response},function(){})   

			}                 
			else 
			if(type == 'data')
			{                            
				if(this._gzip)
				{                            
					chunk = this._gzip.deflate(chunk,'binary');
				}                                              
				
				this._ws.write(chunk,'binary');
			}               
			else
			if(type == 'response')
			{
				this._response = chunk;
			}    
		}

		this._super(type,chunk);
	} 
	
	,startWS:function()
	{         
		var self = this;                  

		//doesn't exist so let's make it exist.
		utils.mkdir_r(this._rootCacheDir,this._cacheDir,function()
		{                    
			self._ws = fs.createWriteStream(self._absPath);    

			self._ws.addListener('error',function(error)
			{
				console.warning('cannot cache file '+self._absPath+': '+error);  
				self.dispose();
			})        
                      
			//let's play catchup                      
			/*for(var i = 0, n = self._buffer.length; i < n; i++)
			{
				var rec = self._buffer[i]; 
				self.record(rec.type,rec.buffer);
			}                                    
			this._buffer = [];*/
		})

	}
	,sendCached:function()
	{          
		var self = this;      
		                            
		
		function end()
		{
			if(self.complete) 
			{                        
				self.emitter().emit('end'); 
				self.removeListeners();
			}  
		}                   
		                             
		//send the headers
		self.emitter().emit('response',self._response);
		          
		fs.createReadStream(self._absPath,{flags: 'r', 
		encoding: 'binary', 
		mode: 0666,
		bufferSize: 4 * 1024})


		.addListener("data", function(chunk){ 
			self.emitter().emit('data',chunk);    
		})
		.addListener("end", function(chunk){ 
			end();
		})
		.addListener("close",function() {     
			end();
		})
		.addListener("error", function (e) {  
			console.warning(e);
			end();
		});
	}
	,dispose2:function()
	{                        
		//only unlink the file if it actually exists. check out router.js
		//to see an example of whythis might be used (request is not cacheable)
		if(this._ws)                  
		fs.unlink(this._absPath,function()
		{
			
		})                     
		
		// this._
	}
}

DBCacher= utils.extend(Cacher,DBCacher);     
HTTPCacher = utils.extend(Cacher,HTTPCacher);

Cacher = exports.Cache = new Cache();
exports.CacheFactory = factory;
exports.cacheDir = __dirname+'/cache';
factory.addCacher('memory',MemCacher);
factory.addCacher('fs',MemCacher);
factory.addCacher('db',DBCacher);
factory.addCacher('none',PassThruCacher);    
factory.addCacher('http',HTTPCacher);

